diff --git a/src/backend/statistics/meson.build b/src/backend/statistics/meson.build
index 9a7bf55e301..450b5ef0c64 100644
--- a/src/backend/statistics/meson.build
+++ b/src/backend/statistics/meson.build
@@ -5,6 +5,7 @@ backend_sources += files(
   'dependencies.c',
   'extended_stats.c',
   'extended_stats_funcs.c',
+  'join_mcv.c',
   'mcv.c',
   'mvdistinct.c',
   'relation_stats.c',
diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index 73a56f1df1d..9faf47cb66a 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -1890,28 +1890,44 @@ ProcessUtilitySlow(ParseState *pstate,
 				{
 					Oid			relid;
 					CreateStatsStmt *stmt = (CreateStatsStmt *) parsetree;
-					RangeVar   *rel = (RangeVar *) linitial(stmt->relations);
-
-					if (!IsA(rel, RangeVar))
-						ereport(ERROR,
-								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-								 errmsg("CREATE STATISTICS only supports relation names in the FROM clause")));
+					Node	   *fromNode = (Node *) linitial(stmt->relations);
 
 					/*
-					 * CREATE STATISTICS will influence future execution plans
-					 * but does not interfere with currently executing plans.
-					 * So it should be enough to take ShareUpdateExclusiveLock
-					 * on relation, conflicting with ANALYZE and other DDL
-					 * that sets statistical information, but not with normal
-					 * queries.
-					 *
-					 * XXX RangeVarCallbackOwnsRelation not needed here, to
-					 * keep the same behavior as before.
+					 * For single-table stats: FROM clause is a simple
+					 * RangeVar, for join stats: FROM clause is a JoinExpr
 					 */
-					relid = RangeVarGetRelid(rel, ShareUpdateExclusiveLock, false);
+					if (IsA(fromNode, RangeVar))
+					{
+						RangeVar   *rel = (RangeVar *) fromNode;
 
-					/* Run parse analysis ... */
-					stmt = transformStatsStmt(relid, stmt, queryString);
+						/*
+						 * CREATE STATISTICS will influence future execution
+						 * plans but does not interfere with currently
+						 * executing plans. So it should be enough to take
+						 * ShareUpdateExclusiveLock on relation, conflicting
+						 * with ANALYZE and other DDL that sets statistical
+						 * information, but not with normal queries.
+						 *
+						 * XXX RangeVarCallbackOwnsRelation not needed here,
+						 * to keep the same behavior as before.
+						 */
+						relid = RangeVarGetRelid(rel, ShareUpdateExclusiveLock, false);
+
+						/* Run parse analysis ... */
+						stmt = transformStatsStmt(relid, stmt, queryString);
+					}
+					else if (IsA(fromNode, JoinExpr))
+					{
+						/* Join statistics passes 0 as relid */
+						relid = InvalidOid;
+
+						/* Run parse analysis ... */
+						stmt = transformStatsStmt(relid, stmt, queryString);
+					}
+					else
+						ereport(ERROR,
+								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+								 errmsg("CREATE STATISTICS only supports relation names or JOIN clauses in the FROM clause")));
 
 					address = CreateStatistics(stmt, true);
 				}
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 88de5c0481c..7f8b5301b17 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -369,7 +369,13 @@ static char *pg_get_indexdef_worker(Oid indexrelid, int colno,
 static void make_propgraphdef_elements(StringInfo buf, Oid pgrelid, char pgekind);
 static void make_propgraphdef_labels(StringInfo buf, Oid elid, const char *elalias, Oid elrelid);
 static void make_propgraphdef_properties(StringInfo buf, Oid ellabelid, Oid elrelid);
-static char *pg_get_statisticsobj_worker(Oid statextid, bool columns_only,
+
+/* Worker modes for pg_get_statisticsobj_worker */
+#define STATS_DEF_FULL			0	/* full CREATE STATISTICS DDL */
+#define STATS_DEF_COLUMNS_ONLY	1	/* columns/expressions only */
+#define STATS_DEF_COLUMNS_FROM	2	/* columns + FROM clause */
+
+static char *pg_get_statisticsobj_worker(Oid statextid, int defmode,
 										 bool missing_ok);
 static char *pg_get_partkeydef_worker(Oid relid, int prettyFlags,
 									  bool attrsOnly, bool missing_ok);
@@ -1969,7 +1975,7 @@ pg_get_statisticsobjdef(PG_FUNCTION_ARGS)
 	Oid			statextid = PG_GETARG_OID(0);
 	char	   *res;
 
-	res = pg_get_statisticsobj_worker(statextid, false, true);
+	res = pg_get_statisticsobj_worker(statextid, STATS_DEF_FULL, true);
 
 	if (res == NULL)
 		PG_RETURN_NULL();
@@ -1984,7 +1990,7 @@ pg_get_statisticsobjdef(PG_FUNCTION_ARGS)
 char *
 pg_get_statisticsobjdef_string(Oid statextid)
 {
-	return pg_get_statisticsobj_worker(statextid, false, false);
+	return pg_get_statisticsobj_worker(statextid, STATS_DEF_FULL, false);
 }
 
 /*
@@ -1997,7 +2003,29 @@ pg_get_statisticsobjdef_columns(PG_FUNCTION_ARGS)
 	Oid			statextid = PG_GETARG_OID(0);
 	char	   *res;
 
-	res = pg_get_statisticsobj_worker(statextid, true, true);
+	res = pg_get_statisticsobj_worker(statextid, STATS_DEF_COLUMNS_ONLY, true);
+
+	if (res == NULL)
+		PG_RETURN_NULL();
+
+	PG_RETURN_TEXT_P(string_to_text(res));
+}
+
+/*
+ * pg_get_statisticsobjdef_columns_from
+ *		Get the columns and FROM clause of an extended statistics definition,
+ *		without the CREATE STATISTICS name (kinds) prefix.
+ *
+ * For regular stats:  "a, b FROM tablename"
+ * For join stats:     "t1.col FROM t2 t2 JOIN t1 t1 ON (t2.fk = t1.id)"
+ */
+Datum
+pg_get_statisticsobjdef_columns_from(PG_FUNCTION_ARGS)
+{
+	Oid			statextid = PG_GETARG_OID(0);
+	char	   *res;
+
+	res = pg_get_statisticsobj_worker(statextid, STATS_DEF_COLUMNS_FROM, true);
 
 	if (res == NULL)
 		PG_RETURN_NULL();
@@ -2009,7 +2037,7 @@ pg_get_statisticsobjdef_columns(PG_FUNCTION_ARGS)
  * Internal workhorse to decompile an extended statistics object.
  */
 static char *
-pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
+pg_get_statisticsobj_worker(Oid statextid, int defmode, bool missing_ok)
 {
 	Form_pg_statistic_ext statextrec;
 	HeapTuple	statexttup;
@@ -2027,8 +2055,17 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 	ListCell   *lc;
 	List	   *exprs = NIL;
 	bool		has_exprs;
+	bool		is_join_stat;
 	int			ncolumns;
 
+	/* Join stat fields */
+	oidvector  *joinrels = NULL;
+	int2vector *keyrefs = NULL;
+	List	   *joinconds = NIL;
+	Oid		   *all_reloids = NULL;
+	char	  **all_aliases = NULL;
+	int			nrels = 0;
+
 	statexttup = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(statextid));
 
 	if (!HeapTupleIsValid(statexttup))
@@ -2041,8 +2078,78 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 	/* has the statistics expressions? */
 	has_exprs = !heap_attisnull(statexttup, Anum_pg_statistic_ext_stxexprs, NULL);
 
+	/* is this a join statistics object? */
+	is_join_stat = !heap_attisnull(statexttup, Anum_pg_statistic_ext_stxjoinrels, NULL);
+
 	statextrec = (Form_pg_statistic_ext) GETSTRUCT(statexttup);
 
+	/*
+	 * For join statistics, load the join-related catalog fields so we can
+	 * emit table-qualified column names and the JOIN ... ON FROM clause.
+	 */
+	if (is_join_stat)
+	{
+		Datum		jdatum;
+		bool		isnull;
+		char	   *str;
+
+		jdatum = SysCacheGetAttr(STATEXTOID, statexttup,
+								 Anum_pg_statistic_ext_stxjoinrels, &isnull);
+		Assert(!isnull);
+		joinrels = (oidvector *) DatumGetPointer(jdatum);
+
+		jdatum = SysCacheGetAttr(STATEXTOID, statexttup,
+								 Anum_pg_statistic_ext_stxkeyrefs, &isnull);
+		Assert(!isnull);
+		keyrefs = (int2vector *) DatumGetPointer(jdatum);
+
+		jdatum = SysCacheGetAttr(STATEXTOID, statexttup,
+								 Anum_pg_statistic_ext_stxjoinconds, &isnull);
+		Assert(!isnull);
+		str = TextDatumGetCString(jdatum);
+		joinconds = (List *) stringToNode(str);
+		pfree(str);
+
+		/* Build relation OID and alias arrays: [stxrelid, joinrels...] */
+		nrels = 1 + joinrels->dim1;
+		all_reloids = palloc(nrels * sizeof(Oid));
+		all_aliases = palloc(nrels * sizeof(char *));
+		all_reloids[0] = statextrec->stxrelid;
+		all_aliases[0] = get_relation_name(statextrec->stxrelid);
+		for (i = 0; i < joinrels->dim1; i++)
+		{
+			all_reloids[i + 1] = joinrels->values[i];
+			all_aliases[i + 1] = get_relation_name(joinrels->values[i]);
+		}
+
+		/*
+		 * Disambiguate aliases when different relations share the same
+		 * unqualified name (e.g., s1.t and s2.t both get alias "t").
+		 * Append _1, _2, ... following the set_rtable_names() convention.
+		 */
+		for (i = 1; i < nrels; i++)
+		{
+			int			j;
+			int			suffix = 0;
+
+			for (j = 0; j < i; j++)
+			{
+				if (strcmp(all_aliases[i], all_aliases[j]) == 0)
+				{
+					char		buf[NAMEDATALEN];
+
+					suffix++;
+					snprintf(buf, sizeof(buf), "%s_%d",
+							 get_relation_name(all_reloids[i]), suffix);
+					all_aliases[i] = pstrdup(buf);
+
+					/* Restart scan to check for further conflicts */
+					j = -1;
+				}
+			}
+		}
+	}
+
 	/*
 	 * Get the statistics expressions, if any.  (NOTE: we do not use the
 	 * relcache versions of the expressions, because we want to display
@@ -2067,7 +2174,7 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 
 	initStringInfo(&buf);
 
-	if (!columns_only)
+	if (defmode == STATS_DEF_FULL)
 	{
 		nsp = get_namespace_name_or_temp(statextrec->stxnamespace);
 		appendStringInfo(&buf, "CREATE STATISTICS %s",
@@ -2115,7 +2222,7 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 		 * kinds.
 		 */
 		if ((!ndistinct_enabled || !dependencies_enabled || !mcv_enabled) &&
-			(ncolumns > 1))
+			(ncolumns > 1 || is_join_stat))
 		{
 			bool		gotone = false;
 
@@ -2151,9 +2258,21 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 		if (colno > 0)
 			appendStringInfoString(&buf, ", ");
 
-		attname = get_attname(statextrec->stxrelid, attnum, false);
+		if (is_join_stat)
+		{
+			/* Join stat: table-qualify column with its relation's alias */
+			int			relidx = keyrefs->values[colno] - 1;
 
-		appendStringInfoString(&buf, quote_identifier(attname));
+			attname = get_attname(all_reloids[relidx], attnum, false);
+			appendStringInfo(&buf, "%s.%s",
+							 quote_identifier(all_aliases[relidx]),
+							 quote_identifier(attname));
+		}
+		else
+		{
+			attname = get_attname(statextrec->stxrelid, attnum, false);
+			appendStringInfoString(&buf, quote_identifier(attname));
+		}
 	}
 
 	context = deparse_context_for(get_relation_name(statextrec->stxrelid),
@@ -2180,9 +2299,66 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 		colno++;
 	}
 
-	if (!columns_only)
-		appendStringInfo(&buf, " FROM %s",
-						 generate_relation_name(statextrec->stxrelid, NIL));
+	if (defmode != STATS_DEF_COLUMNS_ONLY)
+	{
+		if (is_join_stat)
+		{
+			/*
+			 * Emit FROM ... JOIN ... ON syntax for join statistics.
+			 *
+			 * Use schema-qualified relation names with unqualified table
+			 * names as aliases, matching how the column references above are
+			 * emitted.
+			 */
+			appendStringInfo(&buf, " FROM %s %s",
+							 generate_relation_name(statextrec->stxrelid, NIL),
+							 quote_identifier(all_aliases[0]));
+
+			for (i = 0; i < joinrels->dim1; i++)
+			{
+				appendStringInfo(&buf, " JOIN %s %s ON (",
+								 generate_relation_name(joinrels->values[i], NIL),
+								 quote_identifier(all_aliases[i + 1]));
+
+				/* Find the join condition for this relation (varno = i+2) */
+				foreach(lc, joinconds)
+				{
+					OpExpr	   *op = (OpExpr *) lfirst(lc);
+					Var		   *lvar = (Var *) linitial(op->args);
+					Var		   *rvar = (Var *) lsecond(op->args);
+
+					if (lvar->varno == i + 2 || rvar->varno == i + 2)
+					{
+						int			lrelidx = lvar->varno - 1;
+						int			rrelidx = rvar->varno - 1;
+						char	   *lcolname;
+						char	   *rcolname;
+
+						lcolname = get_attname(all_reloids[lrelidx],
+											   lvar->varattno, false);
+						rcolname = get_attname(all_reloids[rrelidx],
+											   rvar->varattno, false);
+						appendStringInfo(&buf, "%s.%s %s %s.%s",
+										 quote_identifier(all_aliases[lrelidx]),
+										 quote_identifier(lcolname),
+										 generate_operator_name(op->opno,
+																lvar->vartype,
+																rvar->vartype),
+										 quote_identifier(all_aliases[rrelidx]),
+										 quote_identifier(rcolname));
+						break;
+					}
+				}
+
+				appendStringInfoChar(&buf, ')');
+			}
+		}
+		else
+		{
+			appendStringInfo(&buf, " FROM %s",
+							 generate_relation_name(statextrec->stxrelid, NIL));
+		}
+	}
 
 	ReleaseSysCache(statexttup);
 
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index e1449654f96..ff8fcbbe1f2 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -2920,8 +2920,14 @@ describeOneTableDetails(const char *schemaname,
 							  "  " CppAsString2(STATS_EXT_NDISTINCT) " = any(stxkind) AS ndist_enabled,\n"
 							  "  " CppAsString2(STATS_EXT_DEPENDENCIES) " = any(stxkind) AS deps_enabled,\n"
 							  "  " CppAsString2(STATS_EXT_MCV) " = any(stxkind) AS mcv_enabled,\n"
-							  "stxstattarget\n"
-							  "FROM pg_catalog.pg_statistic_ext\n"
+							  "stxstattarget,\n");
+			if (pset.sversion >= 190000)
+				appendPQExpBufferStr(&buf,
+									 "pg_catalog.pg_get_statisticsobjdef_columns_from(oid) AS body\n");
+			else
+				appendPQExpBufferStr(&buf,
+									 "NULL AS body\n");
+			appendPQExpBuffer(&buf, "FROM pg_catalog.pg_statistic_ext\n"
 							  "WHERE stxrelid = '%s'\n"
 							  "ORDER BY nsp, stxname;",
 							  oid);
@@ -2992,9 +2998,18 @@ describeOneTableDetails(const char *schemaname,
 						appendPQExpBufferChar(&buf, ')');
 					}
 
-					appendPQExpBuffer(&buf, " ON %s FROM %s",
-									  PQgetvalue(result, i, 4),
-									  PQgetvalue(result, i, 1));
+					/*
+					 * Use pg_get_statisticsobjdef_columns_from() when available
+					 * (PG19+); fall back to simple column list for older
+					 * servers.
+					 */
+					if (!PQgetisnull(result, i, 9))
+						appendPQExpBuffer(&buf, " ON %s",
+										  PQgetvalue(result, i, 9));
+					else
+						appendPQExpBuffer(&buf, " ON %s FROM %s",
+										  PQgetvalue(result, i, 4),
+										  PQgetvalue(result, i, 1));
 
 					/* Show the stats target if it's not default */
 					if (!PQgetisnull(result, i, 8) &&
@@ -3025,9 +3040,15 @@ describeOneTableDetails(const char *schemaname,
 								 "  " CppAsString2(STATS_EXT_MCV) " = any(stxkind) AS mcv_enabled,\n");
 
 			if (pset.sversion >= 130000)
-				appendPQExpBufferStr(&buf, "  stxstattarget\n");
+				appendPQExpBufferStr(&buf, "  stxstattarget,\n");
+			else
+				appendPQExpBufferStr(&buf, "  -1 AS stxstattarget,\n");
+			if (pset.sversion >= 190000)
+				appendPQExpBufferStr(&buf,
+									 "  pg_catalog.pg_get_statisticsobjdef_columns_from(oid) AS body\n");
 			else
-				appendPQExpBufferStr(&buf, "  -1 AS stxstattarget\n");
+				appendPQExpBufferStr(&buf,
+									 "  NULL AS body\n");
 			appendPQExpBuffer(&buf, "FROM pg_catalog.pg_statistic_ext\n"
 							  "WHERE stxrelid = '%s'\n"
 							  "ORDER BY 1;",
@@ -3072,9 +3093,21 @@ describeOneTableDetails(const char *schemaname,
 						appendPQExpBuffer(&buf, "%smcv", gotone ? ", " : "");
 					}
 
-					appendPQExpBuffer(&buf, ") ON %s FROM %s",
-									  PQgetvalue(result, i, 4),
-									  PQgetvalue(result, i, 1));
+					/*
+					 * Use pg_get_statisticsobjdef_columns_from() when available
+					 * (PG19+); fall back to simple column list for older
+					 * servers.
+					 */
+					if (!PQgetisnull(result, i, 9))
+					{
+						appendPQExpBufferChar(&buf, ')');
+						appendPQExpBuffer(&buf, " ON %s",
+										  PQgetvalue(result, i, 9));
+					}
+					else
+						appendPQExpBuffer(&buf, ") ON %s FROM %s",
+										  PQgetvalue(result, i, 4),
+										  PQgetvalue(result, i, 1));
 
 					/* Show the stats target if it's not default */
 					if (strcmp(PQgetvalue(result, i, 8), "-1") != 0)
@@ -5133,7 +5166,11 @@ listExtendedStats(const char *pattern, bool verbose)
 					  gettext_noop("Schema"),
 					  gettext_noop("Name"));
 
-	if (pset.sversion >= 140000)
+	if (pset.sversion >= 190000)
+		appendPQExpBuffer(&buf,
+						  "pg_catalog.pg_get_statisticsobjdef_columns_from(es.oid) AS \"%s\"",
+						  gettext_noop("Definition"));
+	else if (pset.sversion >= 140000)
 		appendPQExpBuffer(&buf,
 						  "pg_catalog.format('%%s FROM %%s', \n"
 						  "  pg_catalog.pg_get_statisticsobjdef_columns(es.oid), \n"
diff --git a/src/include/catalog/pg_statistic_ext.h b/src/include/catalog/pg_statistic_ext.h
index e4a0cb4d41c..2d21365bd98 100644
--- a/src/include/catalog/pg_statistic_ext.h
+++ b/src/include/catalog/pg_statistic_ext.h
@@ -59,6 +59,15 @@ CATALOG(pg_statistic_ext,3381,StatisticExtRelationId)
 	pg_node_tree stxexprs;		/* A list of expression trees for stats
 								 * attributes that are not simple column
 								 * references. */
+
+	/* Fields for join statistics (all NULL for single-table stats) */
+	oidvector	stxjoinrels;	/* other participating relation OIDs */
+	int2vector	stxkeyrefs;		/* parallel to stxkeys: 1-based varno of each
+								 * key's source relation (1=stxrelid,
+								 * 2=stxjoinrels[0], ...) */
+	pg_node_tree stxjoinconds;	/* join conditions as a List of OpExpr nodes;
+								 * Var varnos are 1-based (1=stxrelid,
+								 * 2=stxjoinrels[0], ...) */
 #endif
 
 } FormData_pg_statistic_ext;
@@ -81,6 +90,12 @@ DECLARE_INDEX(pg_statistic_ext_relid_index, 3379, StatisticExtRelidIndexId, pg_s
 MAKE_SYSCACHE(STATEXTOID, pg_statistic_ext_oid_index, 4);
 MAKE_SYSCACHE(STATEXTNAMENSP, pg_statistic_ext_name_index, 4);
 
+/*
+ * For single-table statistics, all stxkeys reference stxrelid's columns.
+ * For join statistics (stxjoinrels IS NOT NULL), some stxkeys reference
+ * columns from the joined tables instead; the oidjoins test accounts for
+ * this by skipping join stats rows.
+ */
 DECLARE_ARRAY_FOREIGN_KEY((stxrelid, stxkeys), pg_attribute, (attrelid, attnum));
 
 #ifdef EXPOSE_TO_CLIENT_CODE
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index 91377a6cde3..efd240bf39c 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -3635,6 +3635,11 @@ typedef struct CreateStatsStmt
 	char	   *stxcomment;		/* comment to apply to stats, or NULL */
 	bool		transformed;	/* true when transformStatsStmt is finished */
 	bool		if_not_exists;	/* do nothing if stats name already exists */
+
+	/* Join statistics fields, populated by transformStatsStmt */
+	Oid			stxrelid;		/* anchor table OID (InvalidOid if not join) */
+	List	   *stxjoinrels;	/* other table OIDs (list of Oid) */
+	List	   *stxjoinconds;	/* equijoin conditions (list of OpExpr) */
 } CreateStatsStmt;
 
 /*
diff --git a/src/include/nodes/pathnodes.h b/src/include/nodes/pathnodes.h
index 27a2c6815b7..26df294d7d0 100644
--- a/src/include/nodes/pathnodes.h
+++ b/src/include/nodes/pathnodes.h
@@ -1530,6 +1530,12 @@ typedef struct StatisticExtInfo
 
 	/* expressions */
 	List	   *exprs;
+
+	/* Join statistics fields (all NIL for single-table stats) */
+	List	   *joinrels;		/* OIDs of other participating relations */
+	List	   *keyattrs;		/* raw stxkeys as list of AttrNumbers */
+	List	   *keyrefs;		/* per-key table ref (1=anchor, 2+=joined) */
+	List	   *joinconds;		/* parsed join conditions (List of OpExpr) */
 } StatisticExtInfo;
 
 /*
diff --git a/src/include/statistics/extended_stats_internal.h b/src/include/statistics/extended_stats_internal.h
index c775442f2ee..7de67f3aebf 100644
--- a/src/include/statistics/extended_stats_internal.h
+++ b/src/include/statistics/extended_stats_internal.h
@@ -68,7 +68,6 @@ typedef struct StatsBuildData
 	bool	  **nulls;
 } StatsBuildData;
 
-
 extern MVNDistinct *statext_ndistinct_build(double totalrows, StatsBuildData *data);
 extern bytea *statext_ndistinct_serialize(MVNDistinct *ndistinct);
 extern MVNDistinct *statext_ndistinct_deserialize(bytea *data);
@@ -96,6 +95,24 @@ extern Datum statext_mcv_import(int elevel, int numattrs, Oid *atttypids,
 								bool *mcv_nulls, float8 *freqs,
 								float8 *base_freqs);
 
+extern Oid	find_index_for_operator(Relation rel, AttrNumber attnum,
+									Oid eq_op);
+
+extern MCVList *statext_join_mcv_build(Relation anchor_rel,
+									   Oid *joinrel_oids,
+									   int njoinrels,
+									   int16 *joinleft,
+									   int16 *joinright,
+									   Oid *joinops,
+									   int njoinquals,
+									   int16 *stxkeys,
+									   int16 *keyrefs,
+									   int nkeys,
+									   int stattarget,
+									   int numrows, HeapTuple *rows,
+									   double totalrows,
+									   VacAttrStats ***result_stats);
+
 extern MultiSortSupport multi_sort_init(int ndims);
 extern void multi_sort_add_dimension(MultiSortSupport mss, int sortdim,
 									 Oid oper, Oid collation);
diff --git a/src/include/statistics/statistics.h b/src/include/statistics/statistics.h
index 8f9b9d237fd..cb76fddfaff 100644
--- a/src/include/statistics/statistics.h
+++ b/src/include/statistics/statistics.h
@@ -128,4 +128,12 @@ extern StatisticExtInfo *choose_best_statistics(List *stats, char requiredkind,
 												int nclauses);
 extern HeapTuple statext_expressions_load(Oid stxoid, bool inh, int idx);
 
+/* Join MCV statistics functions */
+extern Selectivity join_mcv_clause_selectivity(PlannerInfo *root,
+											   RestrictInfo *rinfo);
+extern Selectivity statext_join_mcv_clauselist_selectivity(PlannerInfo *root,
+														   List *clauses,
+														   int varRelid,
+														   Bitmapset **estimatedclauses);
+
 #endif							/* STATISTICS_H */
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index 8fa0a6c47fb..59ebb99a30d 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -83,6 +83,9 @@ test: create_table_like alter_generic alter_operator misc async dbsize merge mis
 # amutils depends on geometry, create_index_spgist, hash_index, brin
 test: rules psql psql_crosstab psql_pipeline amutils stats_ext collate.linux.utf8 collate.windows.win1252
 
+# join MCV statistics tests
+test: stats_ext_crossrel
+
 # ----------
 # Run these alone so they don't run out of parallel workers
 # select_parallel depends on create_misc
diff --git a/src/test/regress/sql/oidjoins.sql b/src/test/regress/sql/oidjoins.sql
index 8b22e6d10c5..2b08ae7b24c 100644
--- a/src/test/regress/sql/oidjoins.sql
+++ b/src/test/regress/sql/oidjoins.sql
@@ -24,6 +24,11 @@ begin
       end loop;
       cmd := cmd || ', unnest(' || quote_ident(fk.fkcols[nkeys]);
       cmd := cmd || ') as ' || quote_ident(fk.fkcols[nkeys]);
+      -- For pg_statistic_ext, include stxkind for join stats filtering
+      if fk.fktable = 'pg_statistic_ext'::regclass and
+         fk.fkcols = ARRAY['stxrelid', 'stxkeys'] then
+        cmd := cmd || ', stxkind, stxjoinrels';
+      end if;
       cmd := cmd || ' FROM ' || fk.fktable::text || ') fk WHERE ';
     else
       cmd := cmd || ' FROM ' || fk.fktable::text || ' fk WHERE ';
@@ -33,6 +38,13 @@ begin
         cmd := cmd || quote_ident(fk.fkcols[i]) || ' != 0 AND ';
       end loop;
     end if;
+    -- Special case: For join statistics, stxkeys references attributes from
+    -- the other table (via stxkeyrefs), not from stxrelid.  Skip the FK
+    -- check for join stats where stxjoinrels is not null.
+    if fk.fktable = 'pg_statistic_ext'::regclass and
+       fk.fkcols = ARRAY['stxrelid', 'stxkeys'] then
+      cmd := cmd || 'stxjoinrels IS NULL AND ';
+    end if;
     cmd := cmd || 'NOT EXISTS(SELECT 1 FROM ' || fk.pktable::text || ' pk WHERE ';
     for i in 1 .. nkeys loop
       if i > 1 then cmd := cmd || ' AND '; end if;
